package vo

import (
	"electricity_bill_calc/model"
	"electricity_bill_calc/types"
)

type TenementCreationForm struct {
	Name           string  `json:"name"`
	ShortName      *string `json:"shortName"`
	Address        string  `json:"address"`
	Contact        string  `json:"contact"`
	Phone          string  `json:"phone"`
	Building       *string `json:"building"`
	OnFloor        *string `json:"onFloor"`
	USCI           string  `json:"usci"`
	InvoiceAddress *string `json:"invoiceAddress"`
	InvoicePhone   *string `json:"invoicePhone"`
	Bank           *string `json:"bank"`
	Account        *string `json:"bankAccount"`
}

type TenementQueryResponse struct {
	Id             string          `json:"id"`
	FullName       string          `json:"fullName"`
	ShortName      *string         `json:"shortName"`
	Address        *string         `json:"address"`
	Contact        *string         `json:"contact" copier:"ContactName"`
	Phone          *string         `json:"phone" copier:"ContactPhone"`
	Building       *string         `json:"building"`
	BuildingName   *string         `json:"buildingName"`
	OnFloor        *string         `json:"onFloor"`
	MovedInAt      *types.Date     `json:"movedInAt"`
	MovedOutAt     *types.Date     `json:"movedOutAt"`
	CreatedAt      types.DateTime  `json:"createdAt"`
	LastModifiedAt *types.DateTime `json:"lastModifiedAt"`
}

type SimplifiedTenementResponse struct {
	Id        string  `json:"id"`
	FullName  string  `json:"fullName"`
	ShortName *string `json:"shortName"`
	Park      string  `json:"park"`
}

type TenementDetailResponse struct {
	Id             string              `json:"id"`
	FullName       string              `json:"fullName"`
	ShortName      *string             `json:"shortName"`
	Address        string              `json:"address"`
	Contact        string              `json:"contact" copier:"ContactName"`
	Phone          string              `json:"phone" copier:"ContactPhone"`
	Building       string              `json:"building"`
	BuildingName   *string             `json:"buildingName"`
	OnFloor        *string             `json:"onFloor"`
	InvoiceInfo    *model.InvoiceTitle `json:"invoiceInfo"`
	MovedInAt      *types.Date         `json:"movedInAt"`
	MovedOutAt     *types.Date         `json:"movedOutAt"`
	CreatedAt      types.DateTime      `json:"createdAt"`
	LastModifiedAt *types.DateTime     `json:"lastModifiedAt"`
}

type SimplifiedTenementDetailResponse struct {
	Id           string      `json:"id"`
	FullName     string      `json:"fullName"`
	ShortName    *string     `json:"shortName"`
	Address      string      `json:"address"`
	Contact      string      `json:"contact" copier:"ContactName"`
	Phone        string      `json:"phone" copier:"ContactPhone"`
	Building     string      `json:"building"`
	BuildingName *string     `json:"buildingName"`
	OnFloor      *string     `json:"onFloor"`
	MovedInAt    *types.Date `json:"movedInAt"`
	MovedOutAt   *types.Date `json:"movedOutAt"`
}
